C........................................................Jun. 2016
C
C........................................................Apr. 2014
C replace hmF2 calculation with
C hmF2=peakh(foE,foF2,XM3000)
C........................................................Oct. 2013
C Exclude Hakura Tables
C Use GEC array instead of IG12 array
C
C........................................................Nov.2012
C NEW!!!!!!!!!
C Produce maps foF2, hmF2, TEC, TECeff in IONEX style format
C Add calculation of TEC(h) profile for [0 20200]km in step of 200 km
C multiplied by Cv(h) coefficients to produce GEC
C Add output of TECeff map with TECeff equal to sum of TEC(h)*Cv(h)
C
C input <jhrgDDD0.iYR IONEX files: +++++++++++++JPL IONEX file +++++++++
C         lati:  87.5, 85.0,...,0,...,-87.5 ==> i=1,2,...71
C         longi:-180.0, -175.0,... 0...180.0 ==> j=0,...,72
C output maps at 
C		   lats=[-87.5, -85.0,...,0,...,87.5 for i= 71, 70,...1
C            longi:-180.0, -175.0,... 0...180.0 ==> j=0,...,72
C
C
C
C .......................................................Feb. 2012
C
C NO!!!!!!!!! Include GEC calculation	for UT=0,1,...,24 hrs UT
C NO!!!!!!!!! outfile='gecyr.br' 
C
C
C T.L.Gulyaeva...........................................June 2011
C
CInclude input of IONEX_1h files <uhrgXXX0.11i>
C Produce fcF2 & hcF2 numerical maps with IRI-Plas code
C for glats [-87.5:2.5:87.5], glons [-180:5:180]
C in 48 daily files: <fcmndyut.syr>,<hcmndyut.syr> for ut=0,1,...,23hUT
C 
      PROGRAM MAPIRIP8jg
C----------------------------------------------------------------
C Select NEW+++:Input 71 (instead of 35) geographic latitudes: res1=87.5,85,,.0..-87.5N 
C at: NEW+++: 0,1,...,72 geographic longitudes [-180,-175,...,180] = IONEX step
C Produce maps fc & hc for 0, 1,..., 23hr UT.syr  
C 2 output arrays for each hourUT =48 daily files 
C <fcmndyut.syr>,<hcmndyut.syr>,<tcmndyut.syr>,<tcmndyut.eyr>
C send results to d:/web/dfc/yr/mn/fcmndyut.syr;
C 				d:/web/dhc/yr/mn/hcmndyut.syr;
C program for EXTRACTING FROM "JPLGdoy0.iYR" ionex_TEC data 
C +++++++++
C Add+Input: selected glats& glons for mlati=+60,+55,...,-60 deg. at MLT=0,1,...,23h MLT.
C++ Add+preprocessing results: TEC(glats=87.5:-2.5-87.5,glons=-180:15:165) Array TECPRE(72,73)
C
C*********TEST
      dimension   outf(0:11,0:120),oarr(50),indap(13),akp(13)
	REAL rkp(0:366,0:7),prekp(0:7),curkp(0:7)
      logical     jf(30),F1REG
	 integer daynr,numhei,ifcf2(71,0:72),ihcf2(71,0:72),itec(71,0:72)
	+,ieff(71,0:72)
	CHARACTER*2 YY,AMN,DY1,DY2,CMN
	 CHARACTER*4 TTT
	character*1 gh
	DIMENSION GLATS(71),GLONS(0:72),resgec(72)  ! GEC results for each latitude
	 INTEGER*2 iyr,imn,idy,nndy,iut,iidy,ndyend
	+,iut0
      common   /block1/hmf2,xnmf2,hmf1,F1REG
     &/PLAS/HPL,XNEPL,XKP,ICALLS,RUT,RLT,OARR,TECI,TCB,TCT,TCPL,TEC
      COMMON   /CONST/UMR/ARGEXP/ARGMAX
     &         /CONST1/HUMR,DUMR,FAP,INDAP,AKP,COV,RZS,HMLON
     &/dem/W,glong,hour,daynr,cn1000,alon,blon,ENRE,HSC
C# new common block:
     &         /QTOP/Y05,H05TOP,QF,XNETOP,XM3000,HHALF,TAU,HTOP
	common /temod/month            ! added in IRIS2006.for	to call Temodel
      COMMON /BL1/AYEAR,YY,AMN,DY1,DY2,DD1,DD2,ID1,ID2,ADY
	 COMMON /BL2/ DD,TTT,ZZ
	COMMON /FIKP/rkp,prekp
C**********TEST
      CHARACTER*128 INFILE,OUTFILEF,OUTFILEH,OUTFILET
	+,OUTFILEE   ! TECeff
C??     +,outfile
	EXTERNAL          XE1,XE2,XE3,XE3_1,XE4,XE5,XE6,XXE6,TEDER,ABLON

	CHARACTER(10) DD
      CHARACTER(10) TT
      CHARACTER(5) ZZ
	CHARACTER*4 AYEAR,RYEAR
C??	,NAME
	CHARACTER*60 txt
	CHARACTER*16 txt1,start
	character*2 ayr,rmn,rdy,ady,aut,ady0
	character*3 aday
	integer*4 ixx(16)
	dimension itxx(0:72),im(12)
	+,itecpre(0:72)  ! driving glats & glons ~ mlat& MLT-bin
	+,teceff(71,0:72)  ! TECeff

	DATA  IM/31,28,31,30,31,30,31,31,30,31,30,31/
C++
C++
      ICALLS=0
	CALL DATE_AND_TIME(DATE=DD,TIME=TT,ZONE=ZZ)
      TT(5:)='      '
      WRITE(*,*) 'PC Date: Year,Month,Day = ',DD,'Time = ',TT
C
      WRITE(*,'(\A\)') ' ENTER YEAR OF INPUT FILE='
      READ(*,'(A)') AYEAR
ctemp	AYEAR='2012'  !ctemp
		ayr=ayear(3:4)

      WRITE(*,'(\A\)') ' ENTER MN OF INPUT FILE='
      READ(*,'(A)') AMN
ctemp	amn='01'

		WRITE(*,*) 'Enter ndy1, ndy2 for input: '
 	read(*,987) nndy,ndyend
  987	format(I2)
	call blet2(nndy,DY1)
	call blet2(ndyend,DY2)
	ady0=DY1
ctemp	nndy=2   ! temp for test
ctemp		ndyend=5  !temp for test
C
c//		outfile='ghYRMN.txt'

	irunkp=0
C
 1001    DO I=1,30
      JF(I)=.TRUE.
      ENDDO
C
	glat=-90.
	DO i=1,71
	glat=glat+2.5
	glats(i)=glat
	ENDDO
C
	glon=-185.
	do i=0,72
	glon=glon+5.0
	glons(i)=glon
	enddo
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

C
Cd	UMR=ATAN(1.0)*4./180.
      IRUN=0 ! NORMAL COMMAND
	iut0=0 ! NORMAL COMMAND
CSTART TEMP: Next two command for starting UT (arbitrary)
CTEMP		iut0=02				!TEMP
CTEMP		irun=02             !TEMP
	ady0=ady
CEND TEMP
C
	start='START OF TEC MAP'
C??		WRITE(*,*) 'Enter <jplg> or <jprg> or <uhrg> for input: '
CREM 	read(*,118) name
c//	name='uhrg' !ctemp
C??	name='jhrg' !ctemp
c//      	name='upcg' !ctemp
CREM		 outfile(8:10)=name(1:3)
  118	format(A4)
cc	pause  ' '
C
C =========================================
C ????????????????????????????????????????
	do k=0,72
	itecpre(k)=0.	! prec. input tec for -180, -175,...00,05,...,180 deg.E
	do i=1,71
	teceff(i,k)=0.	! arrange TECeff for -180, -175,...00,05,...,180 deg.E
	enddo
	enddo
c
	read(ayear,*) xyear
	IYYYY=int(xyear)
	yy=ayr
	read(yy,*) ryr
	iyr=int(ryr)
c
	read(amn,*) xmn
	imn=int(xmn)
C??      outfile(3:4)=yy
C?? 	outfile(5:6)=amn
c//	OPEN(11,FILE=OUTFILE,ACCESS='APPEND') !GEC results

CC
	call blet2(nndy,dy1)
	ady0=dy1
	write(*,199) dy1
  199	format(' day=',A2)
cc	DY1='01'
c//	DY2=DY1
	read(dy1,*) xdy
	idy1=int(xdy)
	if (irunkp.eq.0) then
	CMN=AMN
		      CALL SUBKP
	AMN=CMN
	irunkp=1
	endif
cc	 read(dy2,*) xdy2
cc	idy2=int(xdy2)
	idy2=idy1
c	nrday=int(daynr)

c outfiles =================================
	outfilef='d:\web\dfs\yr\mn\fcmndyut.jyr'  ! ionex type map
	outfilef(12:13)=ayr
	outfilef(15:16)=amn
	outfilef(20:21)=amn
C??	outfilef(22:23)=dy1
	outfilef(28:29)=ayr
	outfileh=outfilef
	outfileh(9:9)='h'
	outfileh(18:18)='h'
	outfilet=outfilef
	 outfilet(9:9)='t'
	outfilet(18:18)='t'
	outfilee=outfilet
	outfilee(9:9)='e'
C//	outfilee(18:19)='et' ! etmndyut.syr ! TECeff for GEC calculation
	outfilee(18:18)='e' ! ecmndyut.jyr ! TECeff for GEC calculation
C++
	ist=0
	JOUT=0
	JSTR=0
	JUC=0
	JMAG=0	! geogr.coord
	RZS=-1. ! temp
       HBEG=80.
		jf(25)=.true.
        oarr(33)=rzs
       JF(3)=.FALSE.
      JF(4)=.FALSE.
      IF (JUC.EQ.2) JF(5)=.FALSE.
C
      IF (JOUT.EQ.0) JF(18)=.FALSE.
      IF (JSTR.EQ.0) JF(26)=.FALSE.

	iiyr=int(xyear)
	if(int(xyear/4.)*4.eq.iiyr) THEN 
	im(2)=29
	                          ELSE
	IM(2)=28
	ENDIF
c	xdy=1.      ! start day-of-month
CC
	infile='d:\web\graf\TECI\YRMNDDt.txt'	!!!!!!!! JPLR-file-hourly NEW
C
	infile(18:19)=ayr		  ! NEW
	infile(20:21)=amn		  ! NEW
C??  800 continue ! cycle on st-to-st

C Cycle day-to-day +++++++++++++++++++++++++++++
  700	DO 800 iidy=nndy,ndyend
C??      iidy=int(xdy)
	call blet2(iidy,ADY)
	infile(22:23)=ady		  ! NEW

	lda=ndoy(iyr,imn,iidy)
	daynr=lda
  178	call blet3(lda,ADAY)

		iflag=0
	pdy='00'
C
   11	continue     ! day-to-day cycle
c//	ih0=-2
c//	if ((iiyr.le.2001).and. then
c//	 ih0=-1
c//	goto 113
c//	endif
c//	if ((iiyr.eq.2002).and.(imn.lt.11)) ih0=-1
  113	CONTINUE
CREM  	infile(22:24)=aday
C+++
C check availability of uhrg file:
   27 format(5X,F3.1)
	OPEN(11,FILE=INFILE,ACTION='READ')
	read (11,27,err=33,end=30) par 
	goto 29
   30	continue
      if (par.eq.0.) then
	goto 18
	else
	goto 29
	endif
   18	CONTINUE
CREM      infile(18:21)='jplg'	! NEW!!!!!!!!!!!!!!!!!!!!!!!
	gh='h'  ! 1h data            ! NEW
C end check
   29	close(unit=11)
C
C fix hour step:
C
CREM	gh=infile(19:19)
C Constant for start UT of map
CREM	ih0=-2
CREM	if ((iiyr.le.2001).and.(gh.ne.'h')) then
CREM	 ih0=-1
CREM	goto 1113
CREM	endif
CREM	if ((iiyr.eq.2002).and.(imn.lt.11)) ih0=-1

 1113	continue
CREM      if (gh.eq.'h') then
	idelh=1
	iruns=24
CREM	       else
CREM	idelh=2
CREM	iruns=13
CREM	endif
	iutend=iruns
CREM	if (ih0.eq.-1) iutend=iruns-1
	
C end fix
		      OPEN(111,FILE=INFILE)
C  Start of daily selection for given day:
		ihr=0              ! start of 1-hr bins or 2-hr bins

CC???	if (gh.eq.'h') goto 114  ! Avoid ihr=1 for hourly input GIM-TEC
CREM	if ((iiyr.le.2001).and.(gh.ne.'h')) then
CREM	 ihr=1
CREM	iut0=1
CREM	goto 114
CREM	endif
CREM	if ((iiyr.eq.2002).and.(imn.lt.11).and.(gh.ne.'h')) then
CREM	ihr=1
CREM	iut0=1
CREM	endif
C
C Prepare results of GEC for UT=0,...,23 + daily mean
  114	CONTINUE
CREM      do n=0,24
cREM 	rgec(n)=0.
CREM	enddo
	
c ***************************************************************
C start cycle on hr-to-hr input:
   80	do i=1,600					             !!
	READ (111,187,END=33,ERR=2) txt,txt1
  187	format(A60,A16)
	if (txt1.eq.start) goto 88
	enddo									 !!
  88	continue
c      write(*,*) txt1
c	pause ' '

C Start of reading VTEC ========================
   	read (111,89,end=9,err=85) ryear,rmn,rdy,iut
CADD++++++++++++++++++++++++++++++++++++++++++++++++
	if (rdy(1:1).eq.' ') rdy(1:1)='0'
	if ((iut.lt.iut0).and.(rdy.eq.ady0)) goto 80  ! ???????????
   89 format(2X,A4,4X,A2,4X,A2,4X,I2)
crem         if (irun.eq.iruns) then	!<<<<<<<
c//	         if (irun.eq.iruns-1) then  ! from GEC
C Avoid using TEC for next day (UT=24h for to-day)
c+++	if (idelh.eq.1) goto 101
c// 	rmn=amn
c//	rdy=ady0                   !from GEC
c//	if (ihr.eq.1) then
c//	iut=23
c//	                   else
c//	iut=24
c//	    endif
c//	endif				 !>>>>>>>>>>>

   85	continue
cc      write(*,89) ryear,rmn,rdy,iut
	rut=float(iut)	
C Temp for 2002 Nov-Dec
C Temp		iiut=int(rut)				!Temp for 2002 Nov-Dec
C Temp 	if(int(rut/2.)*2.eq.iut) THEN   !Temp for 2002 Nov-Dec
C Temp	iut=iut+1		 !Temp for 2002 Nov-Dec
C Temp	endif			 !Temp for 2002 Nov-Dec
	call blet2(iut,AUT)

	outfilef(24:25)=aut  ! true
	outfileh(24:25)=aut  ! true
      outfilet(24:25)=aut  ! true
	outfilee(24:25)=aut   ! true
C
C Start input for given UT:++++++++++++++++++++
C
C =========================================
C
	if (rmn(1:1).eq.' ') rmn(1:1)='0'
 	if (rdy(1:1).eq.' ') rdy(1:1)='0'
	read (rdy,*) day
	idy=int(day)
c	pause ' '
C
C prepare extracting UKP:
	lda=ndoy(iyr,imn,idy)
		do i=0,7
		curkp(i)=rkp(lda,i)
		prekp(i)=rkp(lda-1,i)
		enddo

C +++++++++++ 
	jt=0
C
C 
  	ilat=0
C start cycle on glatitudes:
	glati=90.0
	nnlat=72
	do k=1,72
	resgec(k)=0.
	enddo
C
	DO 777 lat=1,71	   ! Start cycle on glati ++++++++++++++++++++++++++++++++
		ilat=ilat+1   ! ilat=1 for 87.5
	glati=glati-2.5
	ALATI=glati        ! for iriplas
	 
c   77	DO kl=1,72                 ! cycle on latitudes
   87	read (111,90,end=9,err=2) glat,txt
   90	format(2X,F5.1,A60)
  91   	j1=0
C
C Add check of wrong TEC.le.0<=itec_pre +++++++++++++
C
	itec_pre=20	  ! assumed TEC_pre 
	do j=1,4        
	j1=(j-1)*16
   1	READ (111,180,END=9,ERR=2) (ixx(i),i=1,16)
  180	format(16(1X,I4))
	do k=1,16
	if ((ixx(k).le.0).or.(ixx(k).eq.9999)) then
	if (itecpre(j1+k-1).gt.0) then
	ixx(k)=itecpre(j1+k-1)	! replace wrong TEC
	                          else
	ixx(k)=itec_pre ! replace wrong TEC
	endif
	                                       endif
	itxx(j1+k-1)=ixx(k)
	itec_pre=ixx(k)		! latest TEC_pre
	enddo
	enddo			  ! start selection of 4 longitudes
	READ (111,179,END=9,ERR=2) (ixx(i),i=1,9)
  179	format(9(1X,I4))
	do k=1,9
	if ((ixx(k).le.0).or.(ixx(k).eq.9999)) then
	if (itecpre(63+k).gt.0) then
	ixx(k)=itecpre(63+k)	! replace wrong TEC
	                          else
	ixx(k)=itec_pre ! replace wrong TEC
	endif
	                                       endif
	itxx(63+k)=ixx(k)
	itec_pre=ixx(k)		! latest TEC_pre
	enddo
	ilatgec=ilat
CC
	nnlat=nnlat-1  ! Keep results for GLAT=87.5(-87.5) at nnlat=71(1)
C Select values for Long=-180,-165,...0,15,30,..,165,180!!!!!!!!!!!!:
C
	ii=-1
	 jj=71
C====================================================
	do 177 il=-180,180,5     ! for long-cycle
	ii=ii+1					   ! ii=0 for glong=-180,...,ii=72 for glong=180
	ires=ii
CTEMP	if (alati.eq.27.5) then                !TEMP+++++++++++++
CTEMP	ifcf2(nnlat,ires)=ifcf2(nnlat+1,ires)  !TEMP+++++++++++++
CTEMP	ihcf2(nnlat,ires)=ihcf2(nnlat+1,ires)  !TEMP+++++++++++++
CTEMP	 itec(nnlat,ires)=itec(nnlat+1,ires)   !TEMP+++++++++++++
CTEMP	 ieff(nnlat,ires)=ieff(nnlat+1,ires)   !TEMP+++++++++++++
CTEMP	goto 177							   !TEMP+++++++++++++
CTEMP	endif								   !TEMP+++++++++++++


	if (itxx(ii).lt.10) itxx(ii)=10 ! Replace TEC<1 by TEC=1 TECU (=0.1TECU)
	glong=float(il)
CC++
	ALONG=glong
	if (along.lt.0.) along=along+360.
	MMDD=imn*100+idy
 	HOURS=IUT+25.
C extract UKP=maxkp for 6 prec.hrs from rkp array:
	ukp=0.
	iut1=iut/3-1
	iut2=iut1-1
	if (iut1.ge.0) then
	ukp1=curkp(iut1)
	else
	ukp1=prekp(iut1+8)
	endif
	if (iut2.ge.0) then
	ukp2=curkp(iut2)
	else
	ukp2=prekp(iut2+8)
	endif
	UKP=MAX(ukp1,ukp2)
	HMF2I=0.
	FOF2=0.
	itec(nnlat,ires)=itxx(ii)	! remember tec map
	TECI=itxx(ii)/10.
		IF (TECI.LT.2.) TECI=0.
	IF (TECI.GT.0.) JF(30)=.FALSE.
      tec = -111.
      tect= -111.
      tecb= -111.
      TCPL= -111.
	hmf2=0.
	xm3000=0.
CC Call iriplas for fcF2 & hcF2 calculations
c
c     initialize IRI parameter in COMMON blocks
c
      abeg=hbeg
C      aend=hend
      AEND=1336.
      astp=aend-hbeg
	numhei=101      ! 101 ranges = 200 km
C
      call IRIS2014s(JF,JMAG,ALATI,ALONG,IYYYY,MMDD,HOURS,
     &   abeg,aend,numhei,OUTF)
      IF(JF(8)) FOF2=OARR(1)
      IF(JF(9)) HMF2=OARR(2)
      IF(JF(17))  RZS=OARR(33)
	AL=OARR(32)	  ! L value
	IF (AL.GT.99.99) AL=99.99
      XHI=OARR(23)
      YMODI=OARR(27)
CCC
	    GLATI=OARR(37)
          GLONG=OARR(38)                  
	rlt=iut+glong/15.
	if (rlt.lt.0.) rlt=rlt+24.
          XMLAT=OARR(42)
          XMLON=OARR(40)
		HTOP=OARR(46) 
	      TOT=TCB+TCT+TCPL	
		  	XNMF2=XNMF2/1.0E+06
      FOF2=SQRT(XNMF2/1.24E+04)
cc	ifcf2(idy,iut)=nint(foF2*10.)
cc	ihcf2(idy,iut)=nint(hmF2)
	ifcf2(nnlat,ires)=nint(foF2*10.)
	ihcf2(nnlat,ires)=nint(hmF2)
	 ieff(nnlat,ires)=nint(OARR(13)*10.)
CBAK	enddo
  177	continue
c-	ifcf2(nnlat,24)=ifcf2(nnlat,0)
c-	ihcf2(nnlat,24)=ihcf2(nnlat,0)
c-	itec(nnlat,24)=itec(nnlat,0)
C test
	write(*,181) iut,ALATI
cc   	write(*,182)  (ifcf2(nnlat,k),k=0,24)
cc   	write(*,182)  (ihcf2(nnlat,k),k=0,24)
cc	write(*,182)  (itec(nnlat,k),k=0,24)
	do i=0,72
	itecpre(i)=itxx(i)
	enddo
  777	continue   ! End cycle of reading all GLATs
CREM	rgec(iut)=rgec(iut)+GECUT/1.0E+32

  181 format(2X,I2,2X,F5.1)
C
C ==================================================
C
 1611  continue  !  cycle
C --------------- 
C Prepare output of results for nnlong=0,1,...,24

		OPEN(12,FILE=OUTFILEF)
	OPEN(13,FILE=OUTFILEH)
      OPEN(14,FILE=OUTFILET)
	OPEN(15,FILE=OUTFILEE)
C OUTPUT OF RESULTS
	DO nnlat=1,71
CREM	ifcf2(nnlat,72)=ifcf2(nnlat,0)
CREM	ihcf2(nnlat,72)=ihcf2(nnlat,0)
CREM	itec(nnlat,72)=itec(nnlat,0)     
CREM	ieff(nnlat,72)=ieff(nnlat,0)
		write(12,182) (ifcf2(nnlat,k),k=0,72)
		write(13,182) (ihcf2(nnlat,k),k=0,72)
C>	if (iyr.eq.14) then
crem	write(*,182) (itec(nnlat,k),k=0,72)
	write(14,182) (itec(nnlat,k),k=0,72) !OUT of TEC hourly maps
C>	endif
	write(15,182) (ieff(nnlat,k),k=0,72)
	ENDDO
 182	format(73(1X,I4))							
	close(unit=12)
	close(unit=13)
	close(unit=14)
	close(unit=15)

	 
DD  775 continue   ! End calculation for given UT	 
C
    9	continue
C Continue to the next UT hr :
  32		irun=irun+1 
 	ady0=rdy
	if (irun.lt.iutend) goto 80 ! continue to the next UT hr =>>>>
c      if (iut.lt.22) goto 80 ! continue to the next UT hr =>>>>
C	pause ' '
C++++++++++++++++++++++++++++
C Output of GEC results
C

C 
  101 xdy=xdy+1.
cc??/	irun=irun+1
	irun=0
c	pause ' '
	close(unit=111)
	jdy=int(xdy)
ccf (iidy.le.im(mn)) then
	if ((jdy.le.idy2).and.(idy1.lt.idy2)) then
	goto 700                ! continue for the next day of month
	else
		goto 33	   ! end of calculations
	endif
C
c	write (*,888) alat,alon,aday
c  888	format(1X,' alat=',A3,' alon=',A3,' day=',A3)

    2 CONTINUE
      if (irun.eq.0) then
       write(*,*) 'INPUT FILE IS NOT IN YOUR DIRECTORY '
 	pause ' '
	goto 35
      endif

  800 continue ! 	  ! continue for the next day of month

		goto 33	   ! end of calculations
cc 33		if (iidy.le.im(mn)) goto 32
C???   33 if ((iidy.le.idy2).and.(idy1.lt.idy2)) goto 32
   33 CONTINUE
   35      write(*,*) infile,outfilef,outfileh
	write(*,*) irun
C temp
	 nndy=nndy+1
crem	if (nndy.le.im(mn)) then
	if (nndy.le.ndyend) then
	goto 1001
	endif
      pause ' ' 
      STOP
       END

C***********************************************************
